#ifndef __GAME_EVENT_H
#define __GAME_EVENT_H
using namespace std;

namespace Salp {
namespace Game {

enum { EVENT_UNKNOWN=0, EVENT_ADD_ITEM=1 };

struct EventAddItem {
    Game::Item * item;
};

class Event {
    public:

        explicit Event(Uint32 starttime) { type = EVENT_UNKNOWN; start_time = starttime; }
    
        void setTypeAddItem(Game::Item * gi) {
            type = EVENT_ADD_ITEM;
            data.add_item.item = gi;
        }
    
        bool operator>(const Event &a) const {
            return start_time < a.start_time;
        }
        bool operator<(const Event &a) const {
            return start_time > a.start_time;
        }
    
        Uint8   type;
        Uint32  start_time;

        union {
            EventAddItem add_item;
        } data;
};

};
};

#endif
