#include "Gender.h"

namespace Salp {
namespace Game {

Gender::Gender() {
    _gtype = 'n';
}

Gender::Gender(const char type) {
    Gender();
    setGender(type);
}


char Gender::setGender(const char c) {
    // Sets gender, based on suggestion by <c>.
    // If <c> doesn't match any of the proper characters,
    // the 'n' literal (neuter) is chosen.
    switch (c)
    {
        case 'm': case 'M':
            _gtype = 'm';
            break;
            
        case 'f': case 'F':
            _gtype = 'f';
            break;
        
        default:
            _gtype = 'n';    
    }
    
    return _gtype;
}

char Gender::setGender(const char * c)
{
    return setGender(c[0]);
}

string Gender::getGenderString() {
    switch (_gtype) {
        case 'm':  return "male";
        case 'f':  return "female";
        default:   return "neuter";
    }
}

string Gender::getHe() {
    switch (_gtype) {
        case 'm':  return "he";
        case 'f':  return "she";
        default:   return "it";
    }
}

string Gender::getHim() {
    switch (_gtype) {
        case 'm':  return "him";
        case 'f':  return "her";
        default:   return "it";
    }
}

string Gender::getHis() {
    switch (_gtype) {
        case 'm':  return "his";
        case 'f':  return "her";
        default:   return "its";
    }
}


};
};
