#ifndef __GAMEITEMPLATFORM_H
#define __GAMEITEMPLATFORM_H

#include "Game/Item.h"
#include "PathCP.h"

namespace Salp {
namespace Game {

class ItemPlatform : public Item
{
    public:
        explicit ItemPlatform(const Tile::Sequence *tseq,
                        const Uint32 id=0);
        ~ItemPlatform();

        void animate();
        Path * getPath() const; // gets the path -- this is *not* a copy. put it back REAL fast.
        unsigned int getSpeed() const;

        void onCollisionMap();
        void onCollisionItem(Item *victim, unsigned int vic_collide_status);
        void onDrewLastFrame();
        void setBounceEffect(Tile::Sequence *tseq, int dir);
        void setPath(Path *path); // sets the path -- I'll destroy it myself
        void setSpeed(unsigned int speed);

     private:
        unsigned int _movespeed;   // how many pix to move each tick
        Path * _path;              // muh path
        
        
        Tile::Sequence *_bounce_seq, *_default_seq;
        int _bounce_dir;
        
    protected:

};

} // namespace Game
} // namespace Salp

#endif
