// Includes (hopefully) support for:
//   - "effects" (ala r2)
//   - ammo
//   - weapon

#ifndef __GAMEITEMPOWERUP_H
#define __GAMEITEMPOWERUP_H

#include "Game/Item.h"
#include "Game/WeaponStatus.h"

namespace Salp {
namespace Game {

class ItemPowerUp : public Item
{
    public:
        explicit ItemPowerUp(const Tile::Sequence *tseq,
                        const Uint32 id=0);
        ~ItemPowerUp();

        void onCollisionMap();
        void onCollisionItem(Item *victim, unsigned int vic_collide_status);
        void onOOB(bool x_oob, bool y_oob);
        
        void setWeaponStatus(WeaponStatus *wstat) { assert(wstat != 0); _wstat = wstat; }
        
     private:
         WeaponStatus *_wstat;
          
     protected:

};

} // namespace Game
} // namespace Salp

#endif
