#ifndef __GAMEITEMPROJECTILE_H
#define __GAMEITEMPROJECTILE_H

#include "SALPSTUB.h"
#include "Game/Item.h"
#include "Game/NPC.h"

namespace Salp {
namespace Game {


class ItemProjectile : public Item
{
    public:
        explicit ItemProjectile(const Tile::Sequence *tseq, WeaponType wtype,
                        const Uint32 id=0);
        ~ItemProjectile();

        void animate();
        void createEffectDirCollided(Tile::Sequence **tseq);
        unsigned int getSpeed() const;
        WeaponType getWeaponType() { return _wtype; }
        void setSpeed(unsigned int speed);
        void setCollideEffect(Tile::Sequence *tseq) { assert(tseq != 0); _collide_effect = tseq; }
        void setCollideEffectDirectional(Tile::Sequence **tseq); // This is an array
        void setCollideSound(Game::Sound *sound) { assert(sound != 0); _collide_sound = sound; }
        void setOwner(Game::NPC *owner) { _owner = owner; } ;
        void setTarget(Game::NPC *target) { _target = target; } ;
        void onCollisionMap();
        void onCollisionItem(Item *victim, unsigned int vic_collide_status);
        void onOOB(bool x_oob, bool y_oob);

        void setOwnerTargetOnHit(bool should_set);

     private:
         Game::Sound *_collide_sound;
         Tile::Sequence *_collide_effect;
         Tile::Sequence **_collide_effect_dir;
         Game::NPC *_owner;
         Game::NPC *_target;
         int _speed;   // how many pix to move each tick (should be positive)
         bool  _set_owner_target_on_hit;
         WeaponType _wtype;
};

} // namespace Game
} // namespace Salp

#endif
