#ifndef __GAME_NPCBUSHBOMBER_H
#define __GAME_NPCBUSHBOMBER_H

#include <cassert>
#include <iostream>

#include "NPC.h"

namespace Salp {
namespace Game {
    enum BUSH_STATE { BUSH_PEEKING, BUSH_IDLING, BUSH_WALKING };
    class NPCBushBomber : public NPC {
        public:
        
            explicit NPCBushBomber(const Tile::Sequence *tseq=__seq_idle,
                            const Uint32 id=0);
           
            void animate();            
            void fireProjectile();
            Game::Item * getTarget();
            void setTarget(Game::Item *target);
            void onUpdateTarget();
            void onDrewLastFrame();
            void updateSequence();

            static Tile::Sequence *NPCBushBomber::__seq_peek;
            static Tile::Sequence *NPCBushBomber::__seq_walk;
            static Tile::Sequence *NPCBushBomber::__seq_idle;

        private:
            int _bushstate;
            
    };
};
};

#endif
