#include "PathCP.h"

#include <assert.h>

namespace Salp {
namespace Game {

PathCP::PathCP()
{
    _targetpoint = 0; // we want to go to point zero

}

PathCP::~PathCP()
{

}

void PathCP::addControlPoint(int x, int y)
{

    _controlpoints.push_back(new Game::Vector(x, y));
}

unsigned int PathCP::getControlPointCount() const
{
    return _controlpoints.size();
}

void PathCP::getTargCoord(int& targx, int& targy)
{
    // Make sure our target point actually exists. :)
    assert(_targetpoint < _controlpoints.size());

    targx = _controlpoints[_targetpoint]->x;
    targy = _controlpoints[_targetpoint]->y;

}

void PathCP::nextCoord()
{
    // advance to next coordinate
    _targetpoint = (_targetpoint + 1) % _controlpoints.size();
}

} // namespace Game
} // namespace Salp
