#include "PathElliptical.h"
#include <assert.h>
#include <math.h>
#include <iostream>

using namespace std;

namespace Salp {
namespace Game {

PathElliptical::PathElliptical()
{
    _currtheta = 0;

    _xpos = 0;
    _ypos = 0;
}


void PathElliptical::setEllipse(unsigned int xpos, unsigned int ypos, unsigned int xrad, unsigned int yrad,
                unsigned int steps, float rotdeg)
{
    assert(steps != 0);

    _xpos = xpos;
    _ypos = ypos;
    _xrad = xrad;
    _yrad = yrad;
    _stepdeg = 1/(3.14 * (xrad>yrad?xrad:yrad));  //6.28/steps;
    _rotdeg = rotdeg;
}

void PathElliptical::getTargCoord(int& targx, int& targy)
{
    targx = _xpos + int(_xrad * cos(_currtheta));
    targy = _ypos + int(_yrad * sin(_currtheta));
}

void PathElliptical::nextCoord()
{
    assert(_ypos > 0);
    assert(_xpos > 0);

    _currtheta += _stepdeg;
    if(_currtheta >= 6.28) _currtheta = 0;
}
    
} // namespace Game
} // namespace Salp
