#ifndef __GAMEPLAYERSTOMPER_H
#define __GAMEPLAYERSTOMPER_H

#include "Game/Player.h"
#include "Tile/Sequence.h"

namespace Salp {
namespace Game {



class PlayerStomper : public Player
{
    public:
        explicit PlayerStomper(const Tile::Sequence *tseq=0,
                               const Uint32 id=0);
        void animate();
        void explode();
        virtual void onCollisionMap();
        virtual void onCollisionItem(Item *victim, unsigned int vic_collide_status);
        void onDeath(Item *killer);
        void onKill(Item *victim);
        void setKeyState(const unsigned int& keyId,
                                        const bool&   isDown);

        void updateSequence();

        // COMMON
        static Tile::Sequence * __seq_run;
        static Tile::Sequence * __seq_idle;
        static Tile::Sequence * __seq_jump;
        static Tile::Sequence * __seq_walk;
        static Game::Sound    *PlayerStomper::__snd_jump;
        static Game::Sound    *PlayerStomper::__snd_land;
        static Tile::Sequence *PlayerStomper::__seq_poofin;
        static Tile::Sequence *PlayerStomper::__seq_poofout;
        
    private:
        unsigned int _jframesleft; // jumpframes left
        

};

} // namespace Game
} // namespace Salp

#endif
