#ifndef __GAMEPREFBUCKET_H
#define __GAMEPREFBUCKET_H

#include <string>
#include <map>

using namespace std;

namespace Salp {
namespace Game {

class PrefBucket {
    public:
        PrefBucket();
        PrefBucket(string fpath);
        void erase();
        string getVal(const string key);
        string getVal(const string key, const string default_val);
        int getIntVal(const string key);
        int getIntVal(const string key, const string default_val);
        bool hasErrors();
        void parseOpts(char **argv, int argc);
        bool revertToSaved();
        void save();
        void setDefault(string key, string val);
        void setPath(string fpath);
        void setVal(string key, string val);
        void setVal(string key, int val);
    private:
        void logError(string msg);
        string _fpath;   // location of pref file
        map<string, string> _prefs;
        int _error_count;
};

} // namespace Game
} // namespace Salp

#endif
