#ifndef __GAME_SOUND_H
#define __GAME_SOUND_H

#include "SDL_mixer.h"
#include <string>

#include "Game/State.h"

namespace Salp {
namespace Game {
    class Sound {
        public:
            Sound();
            Sound(string name, Uint8 volume=100 ); // 128 max
            ~Sound();
                        
            static Uint8  decMasterVolume(Uint8 volume);
            static void   enableAudio(bool enabled) { _audio_enabled = enabled; }
            int           getId();
            static string getMasterVolumeString(); // returns current volume level (0-100), in string form
            string        getName();
            static Uint8  incMasterVolume(Uint8 volume);
            static bool   isAudioEnabled() { return _audio_enabled; }
            bool          isGood();              // "will the sound work?"
            void          playOnce();
            void          setId(unsigned int id);
            void          setGameState(Game::State *gs);
            static Uint8  setMasterVolume(Uint8 volume);

        private:
            Mix_Chunk          *_chunk; // Our hopefully-loaded sound :-)
            string              _name;
            static Game::State *_gamestate;
            int                 _id;
            Uint8               _initial_volume;
            static Uint8        _master_cutoff; // Val subtracted from volumes when played.
            static bool         _audio_enabled;
          //  int _channel; // Channel sound is [to be] played on.
  
    };
};
};

#endif
