#ifndef GAME_WEAPONSTATUS_H
#define GAME_WEAPONSTATUS_H

#define case_ReturnVarName(TOKTYPE) \
            case TOKTYPE: return #TOKTYPE; break;
#define case_ReturnString(TOKTYPE, STR) \
            case TOKTYPE: return STR; break;

namespace Salp {
namespace Game {

class WeaponStatus {
    public:
        WeaponStatus(WeaponType t, bool has_it=false, int start_ammo=0) {
            ammo_count = start_ammo;
            last_fired = 0;
            type = t;
            has_weapon = has_it;
        };

        void fireWeapon(const bool primary);
        
        string getName() {
            switch (type) {
                case_ReturnString(WEAPON_HOMING, "homing missile")
                case_ReturnString(WEAPON_SALP, "salp")
                case_ReturnString(WEAPON_SHOTGUN, "shotgun")
                case_ReturnString(WEAPON_SPREAD, "spreadshot")
                
                case_ReturnString(WEAPON_MINE, "mine")
                case_ReturnString(WEAPON_PROXY_MINE, "proximity mine")
                case_ReturnString(WEAPON_REMOTE_MINE, "remote mine")
                case_ReturnString(WEAPON_MACHINEGUN, "machine gun")
                case_ReturnString(WEAPON_DUMMY_NPC, "dummy npc")
                case_ReturnString(WEAPON_BLOCK, "block")
                case_ReturnString(WEAPON_REMOTE_MISSILE, "remote missile")
                case_ReturnString(WEAPON_BOXING_GLOVE, "boxing glove")
                case_ReturnString(WEAPON_BOOMERANG, "boomerang")
                
                default:
                    assert(0);
                    return "**UNKNOWN WEAPON**";
            }  
        };
        
        WeaponType     type;
        unsigned int   last_fired;
        int            ammo_count;
        bool           has_weapon;
};

} // namespace Game
} // namespace Salp

#endif
