#ifndef __SALP_RANDBUCKET_H
#define __SALP_RANDBUCKET_H

#include <vector>
using namespace std;

namespace Salp {
namespace General {

template<typename T>
 class RandBucket {
     public:
        RandBucket() { };
        // NOTE: RandBucket does not currently do any cleanup..
        //       so if you have pointers in it or whatever, you could
        //       have memory leaks unless you delete them somewhere
        //       else!
                
        void addItem(T * item) {
            assert(item != 0);
            _items.push_back(item);
        };
        
        T * getItem() {
            assert(_items.size() > 0);
            return _items[rand() % _items.size()];
        };
    
     private:
        vector<T *> _items;
     
 };

};
};

#endif
