#ifndef SALP_GENERAL_H
#define SALP_GENERAL_H

#include <string>
#include "SALP_SDL.h"

#include "Game/PrefBucket.h"
#include "SALPSTUB.h"

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    #define ntoh32(X)  (X)
    #define hton32(X)  (X)
    #define ntoh16(X)  (X)
    #define hton16(X)  (X)
#else
    #define ntoh32(X)  (SDL_Swap32(X))
    #define hton32(X)  (SDL_Swap32(X))
    #define ntoh16(X)  (SDL_Swap16(X))
    #define hton16(X)  (SDL_Swap16(X))
#endif

#ifdef WIN32
#define strcasecmp			strcmpi
#define strncasecmp			strnicmp
#endif

using namespace std;
using namespace Salp;

namespace Salp {
namespace General {

    bool associateSalpProtocolWithApp(); // returns true on success
    void checkForAutoUpdates();
    bool setWorkingDirectory(const string &path);
    int sign (int n);
    string getBaseSalpDir(); // returns path to base salp dir (the dir that contains directories like bin, src, and whatever else)
    string getDirPath(string file_path); // returns path to DIR of filepath
    string getEXEFilePath(); // returns path to the exe running
    string getUserName(); // returns name of user running process
    string itoa(int i);
    string URLEncode(string msg);
    void trim(char *s); // removes beginning and trailing whitespace

    extern char tmp_data[1024];
    extern bool debugGraphics;
    extern bool debugProtocol;
    extern bool debugScoreboard;
    extern bool useTCPNoDelay;
    extern bool useTrainingMode;
};
};

extern Game::PrefBucket *gPrefBucket;
extern Game::State * gGameState;

#endif
