#ifndef SALP_GRAPHICS_H
#define SALP_GRAPHICS_H

#include "SALPSTUB.h"
#include "SALP_SDL.h"

// Common graphic functions

#define CHECKGLERROR                                      \
{                                                       \
    GLenum gl_error;                                    \
    gl_error = glGetError();                            \
                                                        \
    if (gl_error != GL_NO_ERROR)                        \
    {                                                   \
        fprintf(stderr,                                 \
                "testgl:%d: OpenGL error: %d: %s\n",        \
                __LINE__, gl_error, gluErrorString(gl_error));                    \
        exit(1);                                        \
    }                                                   \
}

namespace Salp {
namespace General {
    SDL_Surface *copyToTempSurface(SDL_Surface *screen);
    void initTempSurface(SDL_Surface *screen);
    void fillRectAlpha(SDL_Surface *dst, SDL_Rect *dstrect, Uint32 color, Uint8 alpha);
    SDL_Surface * cloneBitmap(SDL_Surface *src, Uint32 oldcolor, Uint32 newcolor);
    Uint32 getPixel(SDL_Surface *image, unsigned short x, unsigned short y);
    void putPixel(SDL_Surface *surface, int x, int y, Uint32 pixel);
    SDL_Surface *conv_surf_gl(SDL_Surface *s, int want_alpha);
    bool savePPM(SDL_Surface *s, const char *file);
};
};

#endif
