#ifndef __MAIN_INIT_H
#define __MAIN_INIT_H

#include "SALP_SDL.h"
#include "SDL_thread.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "Game/Sock.h"  /* Include this instead of SDL_net */
#include "Game/PrefBucket.h"
#include "Game/OSD.h"
#include "Game/State.h"
#include "Game/Player.h"

#include <map>

using namespace Salp;

void initClient();
void initCommandLine(int argc, char *argv[]);
void initDisplay();
void initJoysticks();
void initMusic();
void initOSD();
void initPrefs();
void initSDL();
void initServer();
void initStaticMedia();
void screenBlit_OpenSplash(SDL_Surface *screen);

extern Game::PrefBucket *gPrefBucket;
extern Game::PrefBucket gCmdLine;
extern int gFullScreen;
extern SDL_Surface  *screen;
extern Game::State *gGameState;
extern Game::OSD    *gOSD;
extern Game::Player *gPlayer;
extern Game::Server *gServer;
extern Game::Client *gClient;
extern SDL_Joystick *gJoystick;
extern map<int, char> gJoystickMap; // key -> KEY_ constant
#endif
