#ifndef __TILELOADER_H
#define __TILELOADER_H

#include <string>
#include <fstream>
#include "SALP_SDL.h"

#include "Tile/Set.h"
#include "Tile/Map.h"
#include "Tile/Sequence.h"
#include "Game/State.h"

namespace Salp {
namespace Tile {

void loadLevel(string levname, Game::State *gs, SDL_Surface *screen);
Tile::Map * loadTileMap(Tile::Set *tset, ifstream& fin);
Tile::Sequence * loadTileSequence(Tile::Set *tset, ifstream& fin);
void loadTileSet(string tsetname, Game::State *gs, SDL_Surface *screen=0);
float strToScrollFactor(string str);


} // namespace Tile
} // namespace Salp

#endif
